package com.terraformersmc.terrestria;

import java.util.HashSet;
import java.util.Set;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import com.terraformersmc.terraform.config.BiomeConfig;
import com.terraformersmc.terraform.config.BiomeConfigHandler;
import com.terraformersmc.terrestria.command.LocateAny;
import com.terraformersmc.terrestria.compat.ClimaticWorldTypeCompat;
import com.terraformersmc.terrestria.init.TerrestriaBiomes;
import com.terraformersmc.terrestria.init.TerrestriaBlocks;
import com.terraformersmc.terrestria.init.TerrestriaEntities;
import com.terraformersmc.terrestria.init.TerrestriaFeatures;
import com.terraformersmc.terrestria.init.TerrestriaGeneration;
import com.terraformersmc.terrestria.init.TerrestriaItems;
import com.terraformersmc.terrestria.init.TerrestriaSurfaces;
import com.terraformersmc.terrestria.item.LogTurnerItem;

import net.fabricmc.api.ModInitializer;
import net.fabricmc.fabric.api.client.itemgroup.FabricItemGroupBuilder;
import net.fabricmc.loader.api.FabricLoader;
import net.minecraft.class_1761;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_2378;
import net.minecraft.class_2960;

public class Terrestria implements ModInitializer {
	public static final String MOD_ID = "terrestria";
	public static class_1761 itemGroup;
	public static BiomeConfigHandler biomeConfigHandler;
	public static final Logger log = LogManager.getLogger(MOD_ID);

	@Override
	public void onInitialize() {
		itemGroup = FabricItemGroupBuilder.build(new class_2960(MOD_ID, "items"), () -> new class_1799(TerrestriaItems.RUBBER_SAPLING));
		biomeConfigHandler = new BiomeConfigHandler(MOD_ID);

		BiomeConfig config = biomeConfigHandler.getBiomeConfig();

		Set<String> enabledBiomes = new HashSet<>();

		TerrestriaBlocks.init();
		TerrestriaItems.init();
		TerrestriaEntities.init();
		TerrestriaFeatures.init();
		TerrestriaSurfaces.init();
		TerrestriaBiomes.init();
		TerrestriaGeneration.init(config, enabledBiomes);

		if (FabricLoader.getInstance().isModLoaded("cwt")) {
			log.info("Terrestria has detected ClimaticWorldType is installed... loading compatibility!");
			ClimaticWorldTypeCompat.init(enabledBiomes);
		}

		biomeConfigHandler.save();

		class_2378.method_10230(class_2378.field_11142, new class_2960(MOD_ID, "log_turner"), new LogTurnerItem(new class_1792.class_1793().method_7892(itemGroup)));
		LocateAny.register();
	}
}
