package com.terraformersmc.terrestria.biome;

import com.terraformersmc.terraform.biome.builder.DefaultFeature;
import com.terraformersmc.terraform.biome.builder.TerraformBiome;
import com.terraformersmc.terrestria.init.TerrestriaBiomes;
import com.terraformersmc.terrestria.init.TerrestriaFeatureConfigs;
import com.terraformersmc.terrestria.init.TerrestriaFeatures;
import com.terraformersmc.terrestria.init.TerrestriaSurfaces;
import net.minecraft.class_1299;
import net.minecraft.class_1959;
import net.minecraft.class_3031;
import net.minecraft.class_3098;
import net.minecraft.class_3101;
import net.minecraft.class_3523;

import static com.terraformersmc.terraform.biome.builder.DefaultFeature.*;

public class CalderaBiomes {
	public static void register() {
		TerraformBiome.Template template = new TerraformBiome.Template(TerraformBiome.builder()
				.waterColor(0x54d3c0)
				.waterFogColor(0x24a0b0)
				.addDefaultFeatures(LAND_CARVERS, STRUCTURES, LAKES, DUNGEONS, MINEABLES, ORES, DISKS, DEFAULT_FLOWERS,
						DEFAULT_GRASS, DEFAULT_MUSHROOMS, DEFAULT_VEGETATION, SPRINGS, FROZEN_TOP_LAYER)
				.addStructureFeature(class_3031.field_13565)
				.addStructureFeature(class_3031.field_13547, new class_3101(0.004D, class_3098.class_3100.field_13692))
				.addDefaultSpawnEntries()
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6114, 3, 1, 4))
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6073, 15, 3, 6))
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6070, 15, 1, 5))
		);

		TerrestriaBiomes.CALDERA = TerrestriaBiomes.register("caldera", template.builder()
				.configureSurfaceBuilder(TerrestriaSurfaces.CALDERA, class_3523.field_15697)
				.precipitation(class_1959.class_1963.field_9382).category(class_1959.class_1961.field_9367)
				.depth(1.5F)
				.scale(0.05F)
				.temperature(0.7F)
				.downfall(0.7F)
				.waterColor(0x54d3c0)
				.waterFogColor(0x24a0b0)
				.build());

		TerrestriaBiomes.CALDERA_BEACH = TerrestriaBiomes.register("caldera_beach", template.builder()
				.configureSurfaceBuilder(TerrestriaSurfaces.CALDERA, class_3523.field_15697)
				.precipitation(class_1959.class_1963.field_9382).category(class_1959.class_1961.field_9363)
				.depth(2.25F)
				.scale(0F)
				.temperature(0.7F)
				.downfall(0.7F)
				.build());

		TerrestriaBiomes.CALDERA_FOOTHILLS = TerrestriaBiomes.register("caldera_foothills", template.builder()
				.configureSurfaceBuilder(class_3523.field_15692, class_3523.field_15677)
				.precipitation(class_1959.class_1963.field_9383).category(class_1959.class_1961.field_9357)
				.depth(1.7F)
				.scale(0.4F)
				.temperature(0.0F)
				.downfall(0.1F)
				.waterColor(4159204)
				.waterFogColor(329011)
				.addRareTreeFeature(TerrestriaFeatures.REDWOOD_TREE.method_23397(TerrestriaFeatureConfigs.REDWOOD), 2)
				.addRareTreeFeature(TerrestriaFeatures.HEMLOCK_TREE.method_23397(TerrestriaFeatureConfigs.HEMLOCK), 2)
				.addTreeFeature(class_3031.field_13510.method_23397(TerrestriaFeatureConfigs.TINY_REDWOOD), 1)
				.addTreeFeature(class_3031.field_13510.method_23397(TerrestriaFeatureConfigs.TINY_HEMLOCK), 1)
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6055, 5, 4, 4))
				.build());

		TerrestriaBiomes.CALDERA_RIDGE = TerrestriaBiomes.register("caldera_ridge", template.builder()
				.configureSurfaceBuilder(class_3523.field_15701, class_3523.field_15677)
				.precipitation(class_1959.class_1963.field_9382).category(class_1959.class_1961.field_9357)
				.depth(4F)
				.scale(0F)
				.temperature(0F)
				.downfall(1F)
				.waterColor(4159204)
				.waterFogColor(329011)
				.addTreeFeature(class_3031.field_13510.method_23397(TerrestriaFeatureConfigs.TINY_REDWOOD), 1)
				.addTreeFeature(class_3031.field_13510.method_23397(TerrestriaFeatureConfigs.TINY_HEMLOCK), 1)
				.build());
	}
}
