package com.terraformersmc.terrestria.biome;

import com.terraformersmc.terraform.biome.builder.TerraformBiome;
import com.terraformersmc.terrestria.init.TerrestriaBiomes;
import com.terraformersmc.terrestria.init.TerrestriaFeatureConfigs;
import com.terraformersmc.terrestria.init.TerrestriaFeatures;
import net.minecraft.class_1299;
import net.minecraft.class_1959;
import net.minecraft.class_2246;
import net.minecraft.class_3031;
import net.minecraft.class_3098;
import net.minecraft.class_3101;
import net.minecraft.class_3523;

import static com.terraformersmc.terraform.biome.builder.DefaultFeature.*;

public class HemlockRainforestBiomes {
	public static void register() {
		TerraformBiome.Template template = new TerraformBiome.Template(TerraformBiome.builder()
				.configureSurfaceBuilder(class_3523.field_15701, class_3523.field_15677)
				.precipitation(class_1959.class_1963.field_9382).category(class_1959.class_1961.field_9361)
				.temperature(0.6F)
				.downfall(0.9F)
				.waterColor(4159204)
				.waterFogColor(329011)
				.addDefaultFeatures(LAND_CARVERS, STRUCTURES, LAKES, DUNGEONS, LARGE_FERNS, MINEABLES, ORES, DISKS,
						TAIGA_GRASS, DEFAULT_MUSHROOMS, DEFAULT_VEGETATION, SPRINGS, SWEET_BERRY_BUSHES_SNOWY, FROZEN_TOP_LAYER)
				.addGrassFeature(class_2246.field_10479.method_9564(), 4)
				.addGrassFeature(class_2246.field_10112.method_9564(), 12)
				.addStructureFeature(class_3031.field_13565)
				.addStructureFeature(class_3031.field_13547, new class_3101(0.004D, class_3098.class_3100.field_13692))
				.addDefaultSpawnEntries()
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6055, 8, 4, 4))
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6140, 4, 2, 3))
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_17943, 8, 2, 4))
		);

		TerrestriaBiomes.HEMLOCK_CLEARING = TerrestriaBiomes.register("hemlock_clearing", template.builder()
				.depth(0.95F)
				.scale(0.2F)
				.addTreeFeature(TerrestriaFeatures.HEMLOCK_TREE.method_23397(TerrestriaFeatureConfigs.HEMLOCK), 1)
				.addTreeFeature(class_3031.field_13510.method_23397(TerrestriaFeatureConfigs.TINY_HEMLOCK), 1)
				.addTreeFeature(TerrestriaFeatures.FALLEN_HEMLOCK_LOG.method_23397(TerrestriaFeatureConfigs.FALLEN_HEMLOCK_LOG), 2)
				.build());

		TerrestriaBiomes.HEMLOCK_RAINFOREST = TerrestriaBiomes.register("hemlock_rainforest", template.builder()
				.depth(0.95F)
				.scale(0.55F)
				.addTreeFeature(TerrestriaFeatures.MEGA_HEMLOCK_TREE.method_23397(TerrestriaFeatureConfigs.MEGA_HEMLOCK), 8)
				.addTreeFeature(TerrestriaFeatures.HEMLOCK_TREE.method_23397(TerrestriaFeatureConfigs.HEMLOCK), 8)
				.addTreeFeature(TerrestriaFeatures.FALLEN_HEMLOCK_LOG.method_23397(TerrestriaFeatureConfigs.FALLEN_HEMLOCK_LOG), 4)
				.addTreeFeature(class_3031.field_13510.method_23397(TerrestriaFeatureConfigs.TINY_HEMLOCK), 1)
				.build());
	}
}
