package com.terraformersmc.terrestria.biome;

import com.terraformersmc.terraform.biome.builder.TerraformBiome;
import com.terraformersmc.terrestria.init.TerrestriaBiomes;
import com.terraformersmc.terrestria.init.TerrestriaFeatureConfigs;
import com.terraformersmc.terrestria.init.TerrestriaFeatures;
import net.minecraft.class_1299;
import net.minecraft.class_1959;
import net.minecraft.class_2246;
import net.minecraft.class_3031;
import net.minecraft.class_3098;
import net.minecraft.class_3101;
import net.minecraft.class_3523;

import static com.terraformersmc.terraform.biome.builder.DefaultFeature.*;

public class RedwoodForestBiomes {
	public static void register() {
		TerraformBiome.Template template = new TerraformBiome.Template(TerraformBiome.builder()
				.configureSurfaceBuilder(class_3523.field_15688, class_3523.field_15677)
				.precipitation(class_1959.class_1963.field_9382).category(class_1959.class_1961.field_9361)
				.temperature(0.9F)
				.downfall(0.9F)
				.waterColor(4159204)
				.waterFogColor(329011)
				.addDefaultFeatures(LAND_CARVERS, STRUCTURES, LAKES, DUNGEONS, LARGE_FERNS, MINEABLES, ORES, DISKS,
						TAIGA_GRASS, DEFAULT_MUSHROOMS, DEFAULT_VEGETATION, SPRINGS, SWEET_BERRY_BUSHES_SNOWY,
						FROZEN_TOP_LAYER)
				.addStructureFeature(class_3031.field_13565)
				.addStructureFeature(class_3031.field_13547, new class_3101(0.004D, class_3098.class_3100.field_13692))
				.addDefaultSpawnEntries()
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6055, 8, 4, 4))
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6140, 4, 2, 3))
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_17943, 8, 2, 4))
		);

		TerrestriaBiomes.REDWOOD_FOREST = TerrestriaBiomes.register("redwood_forest", template.builder()
				.depth(1.2F)
				.scale(0.3F)
				.addTreeFeature(TerrestriaFeatures.MEGA_REDWOOD_TREE.method_23397(TerrestriaFeatureConfigs.MEGA_REDWOOD), 7)
				.addTreeFeature(TerrestriaFeatures.FALLEN_REDWOOD_LOG.method_23397(TerrestriaFeatureConfigs.FALLEN_REDWOOD_LOG), 3)
				.addRareTreeFeature(class_3031.field_13510.method_23397(TerrestriaFeatureConfigs.TINY_REDWOOD), 1)
				.addGrassFeature(class_2246.field_10112.method_9564(), 4)
				.addDoubleGrassFeature(class_2246.field_10313.method_9564(), 7)
				.addDoubleGrassFeature(class_2246.field_10214.method_9564(), 7)
				.build());

		TerrestriaBiomes.REDWOOD_FOREST_EDGE = TerrestriaBiomes.register("redwood_forest_edge", template.builder()
				.depth(0.5F)
				.scale(0.3F)
				.addTreeFeature(TerrestriaFeatures.REDWOOD_TREE.method_23397(TerrestriaFeatureConfigs.REDWOOD), 3)
				.addTreeFeature(class_3031.field_13510.method_23397(TerrestriaFeatureConfigs.TINY_REDWOOD), 2)
				.addDoubleGrassFeature(class_2246.field_10313.method_9564(), 4)
				.addDoubleGrassFeature(class_2246.field_10214.method_9564(), 4)
				.build());

		TerrestriaBiomes.REDWOOD_CLEARING = TerrestriaBiomes.register("redwood_clearing", template.builder()
				.depth(1.2F)
				.scale(0.3F)
				.addTreeFeature(TerrestriaFeatures.FALLEN_REDWOOD_LOG.method_23397(TerrestriaFeatureConfigs.FALLEN_REDWOOD_LOG), 2)
				.addTreeFeature(class_3031.field_13510.method_23397(TerrestriaFeatureConfigs.TINY_REDWOOD), 2)
				.addDoubleGrassFeature(class_2246.field_10313.method_9564(), 4)
				.addDoubleGrassFeature(class_2246.field_10214.method_9564(), 4)
				.build());
	}
}
