package com.terraformersmc.terrestria.feature.trees.decorator;

import com.google.common.collect.ImmutableMap;
import com.mojang.datafixers.Dynamic;
import com.mojang.datafixers.types.DynamicOps;
import com.terraformersmc.terraform.block.SmallLogBlock;
import com.terraformersmc.terrestria.init.TerrestriaFeatures;
import java.util.List;
import java.util.Random;
import java.util.Set;
import java.util.function.Predicate;
import net.minecraft.class_1936;
import net.minecraft.class_2338;
import net.minecraft.class_2378;
import net.minecraft.class_2397;
import net.minecraft.class_2680;
import net.minecraft.class_3341;
import net.minecraft.class_4662;

public class FixSmallLogsDecorator extends class_4662 {
	public FixSmallLogsDecorator() {
		super(TerrestriaFeatures.FIX_SMALL_LOGS_DECORATOR);
	}

	public <T> FixSmallLogsDecorator(Dynamic<T> dynamic) {
		this();
	}

	@Override
	public void method_23469(class_1936 world, Random rand, List<class_2338> logs, List<class_2338> leaves, Set<class_2338> placed, class_3341 box) {
		for (class_2338 log : logs) {
			class_2680 existing = world.method_8320(log);

			if(!(existing.method_11614() instanceof SmallLogBlock)) {
				continue;
			}

			boolean hasLeaves = existing.method_11654(SmallLogBlock.HAS_LEAVES);

			Predicate<class_2680> tester =
					tested ->
							tested.method_11614() instanceof SmallLogBlock ||
							(!hasLeaves && tested.method_11614() instanceof class_2397) ||
							tested.method_11619();

			method_23470(
					world,
					log,
					existing
							.method_11657(SmallLogBlock.UP, world.method_16358(log.method_10084(), tester))
							.method_11657(SmallLogBlock.DOWN, world.method_16358(log.method_10074(), tester))
							.method_11657(SmallLogBlock.NORTH, world.method_16358(log.method_10095(), tester))
							.method_11657(SmallLogBlock.EAST, world.method_16358(log.method_10078(), tester))
							.method_11657(SmallLogBlock.SOUTH, world.method_16358(log.method_10072(), tester))
							.method_11657(SmallLogBlock.WEST, world.method_16358(log.method_10067(), tester)),
					placed,
					box
			);
		}
	}

	public <T> T method_19508(DynamicOps<T> ops) {
		return new Dynamic<T>(
				ops,
				ops.createMap(ImmutableMap.of(
						ops.createString("type"),
						ops.createString(class_2378.field_21448.method_10221(this.field_21319).toString())
				))
		).getValue();
	}
}
