package com.terraformersmc.terrestria.feature.trees.decorator;

import com.google.common.collect.ImmutableMap;
import com.mojang.datafixers.Dynamic;
import com.mojang.datafixers.types.DynamicOps;
import com.terraformersmc.terrestria.init.TerrestriaBlocks;
import com.terraformersmc.terrestria.init.TerrestriaFeatures;
import java.util.List;
import java.util.Random;
import java.util.Set;
import net.minecraft.class_1936;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2378;
import net.minecraft.class_2682;
import net.minecraft.class_2902;
import net.minecraft.class_2944;
import net.minecraft.class_3341;
import net.minecraft.class_3486;
import net.minecraft.class_4662;

public class SakuraLeafPileDecorator extends class_4662 {
	private int chance;

	public SakuraLeafPileDecorator(int chance) {
		super(TerrestriaFeatures.SAKURA_LEAF_PILE_DECORATOR);

		this.chance = chance;
	}
	
	public <T> SakuraLeafPileDecorator(Dynamic<T> dynamic) {
		this(dynamic.get("chance").asInt(1));
	}
	
	@Override
	public void method_23469(class_1936 world, Random rand, List<class_2338> logs, List<class_2338> leaves, Set<class_2338> placed, class_3341 box) {
		for(class_2338 pos: leaves) {
			if (rand.nextInt(chance) != 0) {
				continue;
			}

			class_2338 top = world.method_8598(class_2902.class_2903.field_13203, pos);

			if (!class_2944.method_16424(world, top)) {
				continue;
			}

			boolean valid = world.method_16358(top.method_10074(),
					state -> state.method_11618().method_15772().method_15791(class_3486.field_15517) ||
							state.method_20827(class_2682.field_12294, top.method_10074(), class_2350.field_11036)
			);

			if (valid) {
				// setBlockState
				method_23470(world, top, TerrestriaBlocks.SAKURA_LEAF_PILE.method_9564(), placed, box);
			}
		}
	}

	public <T> T method_19508(DynamicOps<T> ops) {
		return new Dynamic<T>(
				ops,
				ops.createMap(ImmutableMap.of(
						ops.createString("type"),
						ops.createString(class_2378.field_21448.method_10221(this.field_21319).toString()),
						ops.createString("chance"),
						ops.createInt(chance)
				))
		).getValue();
	}
}
