package com.terraformersmc.terrestria.feature.volcano;

import com.mojang.datafixers.Dynamic;
import com.terraformersmc.terrestria.init.TerrestriaBiomes;
import java.util.Random;
import java.util.function.Function;
import net.minecraft.class_1923;
import net.minecraft.class_1959;
import net.minecraft.class_2338;
import net.minecraft.class_2794;
import net.minecraft.class_2919;
import net.minecraft.class_3111;
import net.minecraft.class_3195;
import net.minecraft.class_3341;
import net.minecraft.class_3449;
import net.minecraft.class_3485;
import net.minecraft.class_4543;

public class VolcanoStructureFeature extends class_3195<class_3111> {
	//
	private static final int VOLCANO_SPACING = 6;

	// How many chunks should be in between each volcano at least
	private static final int VOLCANO_SEPARATION = 3;
	private static final int SEED_MODIFIER = 0x0401C480;

	public VolcanoStructureFeature(Function<Dynamic<?>, ? extends class_3111> function) {
		super(function);
	}

	protected class_1923 method_14018(class_2794<?> chunkGenerator_1, Random random_1, int chunkX, int chunkZ, int scaleX, int scaleZ) {
		chunkX += VOLCANO_SPACING * scaleX;
		chunkZ += VOLCANO_SPACING * scaleZ;

		// Adjust to grid position
		chunkX = chunkX < 0 ? chunkX - VOLCANO_SPACING + 1 : chunkX;
		chunkZ = chunkZ < 0 ? chunkZ - VOLCANO_SPACING + 1 : chunkZ;

		int finalChunkX = chunkX / VOLCANO_SPACING;
		int finalChunkZ = chunkZ / VOLCANO_SPACING;

		((class_2919) random_1).method_12665(chunkGenerator_1.method_12101(), finalChunkX, finalChunkZ, SEED_MODIFIER);

		// Get random position within grid area
		finalChunkX *= VOLCANO_SPACING;
		finalChunkZ *= VOLCANO_SPACING;
		finalChunkX += random_1.nextInt(VOLCANO_SPACING - VOLCANO_SEPARATION);
		finalChunkZ += random_1.nextInt(VOLCANO_SPACING - VOLCANO_SEPARATION);

		return new class_1923(finalChunkX, finalChunkZ);
	}

	@Override
	public boolean method_14026(class_4543 biomeAccess, class_2794<?> generator, Random random, int chunkX, int chunkZ, class_1959 biomeIn) {
		class_1923 start = this.method_14018(generator, random, chunkX, chunkZ, 0, 0);

		if (chunkX == start.field_9181 && chunkZ == start.field_9180) {
			class_1959 biome = biomeAccess.method_22393(new class_2338(chunkX * 16 + 9, 0, chunkZ * 16 + 9));

			if (biome.method_8688() == class_1959.class_1961.field_9367 && random.nextInt(4) != 0) {
				return false;
			} else if (biome == TerrestriaBiomes.VOLCANIC_ISLAND_SHORE && random.nextInt(2) != 0) {
				return false;
			}

			return generator.method_12097(biome, this);
		}

		return false;
	}

	public class_3195.class_3774 method_14016() {
		return VolcanoStructureStart::new;
	}

	public String method_14019() {
		return "Volcano";
	}

	public int method_14021() {
		return 12;
	}

	public static class VolcanoStructureStart extends class_3449 {
		VolcanoStructureStart(class_3195<?> feature, int chunkX, int chunkZ, class_3341 box, int references, long baseSeed) {
			super(feature, chunkX, chunkZ, box, references, baseSeed);
		}

		public void method_16655(class_2794<?> generator, class_3485 manager, int chunkX, int chunkZ, class_1959 biome) {
			VolcanoGenerator volcano = new VolcanoGenerator(this.field_16715, chunkX * 16, chunkZ * 16, biome);

			this.field_15325.add(volcano);
			this.method_14969();
		}
	}
}
