package com.terraformersmc.terrestria.init.helpers;

import com.terraformersmc.terraform.entity.TerraformBoatEntity;
import com.terraformersmc.terraform.item.TerraformBoatItem;
import java.util.function.Supplier;
import net.minecraft.class_1299;
import net.minecraft.class_1747;
import net.minecraft.class_1822;

public class WoodItems {

	public class_1747 log;
	public class_1747 wood;
	public class_1747 leaves;
	public class_1747 planks;
	public class_1747 slab;
	public class_1747 stairs;
	public class_1747 fence;
	public class_1747 fenceGate;
	public class_1747 door;
	public class_1747 button;
	public class_1747 pressurePlate;
	public class_1822 sign;
	public class_1747 trapdoor;
	public class_1747 strippedLog;
	public class_1747 strippedWood;
	public TerraformBoatItem boat;

	private WoodItems() {
	}

	public static WoodItems register(String name, WoodBlocks blocks, Supplier<class_1299<TerraformBoatEntity>> boatType) {
		WoodItems items = new WoodItems();

		items.log = TerrestriaRegistry.registerBlockItem(name + "_log", blocks.log);
		items.leaves = TerrestriaRegistry.registerBlockItem(name + "_leaves", blocks.leaves);
		items.planks = TerrestriaRegistry.registerBlockItem(name + "_planks", blocks.planks);
		items.slab = TerrestriaRegistry.registerBlockItem(name + "_slab", blocks.slab);
		items.stairs = TerrestriaRegistry.registerBlockItem(name + "_stairs", blocks.stairs);
		items.fence = TerrestriaRegistry.registerBlockItem(name + "_fence", blocks.fence);
		items.fenceGate = TerrestriaRegistry.registerBlockItem(name + "_fence_gate", blocks.fenceGate);
		items.door = TerrestriaRegistry.registerBlockItem(name + "_door", blocks.door);
		items.button = TerrestriaRegistry.registerBlockItem(name + "_button", blocks.button);
		items.pressurePlate = TerrestriaRegistry.registerBlockItem(name + "_pressure_plate", blocks.pressurePlate);
		items.trapdoor = TerrestriaRegistry.registerBlockItem(name + "_trapdoor", blocks.trapdoor);
		items.sign = TerrestriaRegistry.registerSignItem(name + "_sign", blocks.sign, blocks.wallSign);
		items.strippedLog = TerrestriaRegistry.registerBlockItem("stripped_" + name + "_log", blocks.strippedLog);
		items.boat = TerrestriaRegistry.registerBoatItem(name + "_boat", boatType);

		if (blocks.log != blocks.wood) {
			items.wood = TerrestriaRegistry.registerBlockItem(name + "_wood", blocks.wood);
		} else {
			items.wood = items.log;
		}

		if (blocks.strippedLog != blocks.strippedWood) {
			items.strippedWood = TerrestriaRegistry.registerBlockItem("stripped_" + name + "_wood", blocks.strippedWood);
		} else {
			items.strippedWood = items.strippedLog;
		}

		return items;
	}
}
