package com.terraformersmc.terrestria.mixin;

import com.terraformersmc.terrestria.init.TerrestriaBlocks;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2944;
import net.minecraft.class_3031;
import net.minecraft.class_3746;
import net.minecraft.class_3747;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

@Mixin(class_2944.class)
public abstract class MixinAbstractTreeFeature extends class_3031 {
	// Bypasses the "no default constructor" error
	private MixinAbstractTreeFeature() {
		super(null);

		throw new UnsupportedOperationException();
	}

	@Inject(method = "isNaturalDirt", at = @At("HEAD"), cancellable = true)
	private static void hookIsNaturalDirt(class_3746 world, class_2338 pos, CallbackInfoReturnable<Boolean> callback) {
		if (world.method_16358(pos, state -> {
			class_2248 block = state.method_11614();
			return block == TerrestriaBlocks.BASALT_GRASS_BLOCK;
		})) {
			callback.setReturnValue(false);
		}
	}

	// TODO: Basalt farmland when added
	/*@Inject(method = "isDirtOrGrass", at = @At("HEAD"), cancellable = true)
	private static void hookIsDirtOrGrass(TestableWorld world, BlockPos pos, CallbackInfoReturnable<Boolean> callback) {
		if (world.testBlockState(pos, state -> {
			Block block = state.getBlock();
			return block == TerrestriaBlocks.BASALT_FARMLAND;
		})) {
			callback.setReturnValue(true);
		}
	}*/

	@Inject(method = "setToDirt", at = @At("HEAD"), cancellable = true)
	private void hookSetToDirt(class_3747 world, class_2338 pos, CallbackInfo callback) {
		if (world.method_16358(pos, state -> {
			class_2248 block = state.method_11614();
			return block == TerrestriaBlocks.BASALT_GRASS_BLOCK || block == TerrestriaBlocks.BASALT_DIRT;
		})) {
			super.method_13153(world, pos, TerrestriaBlocks.BASALT_DIRT.method_9564());

			callback.cancel();
		}
	}

}
